
package de.ivu.elect.presentation.praesentation.menu;

import java.util.Collections;
import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.internet.boundary.InternetPraesentationErmittler;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.jee.faces.FacesContextUtil;
import de.ivu.elect.presentation.ergebnis.menu.ErgebnisMenuDisabled;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.praesentation.PraesentationExportieren;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public class PraesentationGenerierenMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient ErgebnisMenuDisabled ergebnisMenuDisabled;

  @Inject
  private transient InternetPraesentationErmittler internetPraesentationErmittler;

  @Inject
  private transient PraesentationExportieren praesentationExportieren;

  public PraesentationGenerierenMenuItemEntry() {
    super();
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.PRAESENTATION_EXPORTIEREN) && internetPraesentationErmittler.getInternetPraesentationTyp().isPraesentationVerfuegbar();
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return KEINE_GEBIET_SECURITY;
  }

  @Override
  protected boolean isDisabledInternal() {
    return ergebnisMenuDisabled.isDisabled(this) || !isGenierienMoeglich();
  }

  private boolean isGenierienMoeglich() {
    return praesentationExportieren.isExportierenMoeglich();
  }

  @Override
  protected boolean isShowBlockUi() {
    return true;
  }

  @Override
  public String getTargetViewId() {
    return KEIN_TARGET;
  }

  @Override
  public String doAction() {
    praesentationExportieren.exportiereInternetPraesentation();

    return FacesContextUtil.getCurrentViewId();
  }

  @Override
  protected String buildUrlForTargetViewId(String viewID) {
    return viewID;
  }

  @Override
  public String getLabelKey() {
    return "praesentation.konfiguration.button.internet.exportieren";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconPublish();
  }

  @Override
  protected List<String> getAdditionalTopicViewIds() {
    return Collections.singletonList("");
  }
}
